<?php
/*
 * Created on Oct 13, 2004
 *
 * Novi, poboljani template sustav
 * 
 * NAPOMENA str_replace je bra od svih drugih funkcija kada se ne radi o
 * paternu, to se rada s paternim tie sve funkcije s prefiksom preg_ su do 4x
 * bre
 */
 	
 	class noc_template_replacer
 	{
 		var $tag = array();
		var $value = array();
		var $parsed_block = "";
		
		var $block_name = "";
		var $blocks = array();
		
		var $children = array();
						
		function noc_template_replacer($block_name, &$blocks_ref) 
		{
			$this->block_name = $block_name;
			$this->blocks = &$blocks_ref;
		}
		
		function replace($tag, $value)
		{
			array_push($this->tag, "{{$tag}}");
			array_push($this->value, $value);			
		}
		
		function parse()
 		{
			$keys = array_keys($this->children);
 			foreach ($keys as $key)
 			{
	 			$parsed_block = "";
	 			foreach($this->children[$key] as $child)
	 			{
	 				$child->parse();
	 				$parsed_block = $parsed_block . $child->parsed_block;	 				
	 			}	 			
	 			array_push($this->tag, $this->blocks[$key]); 
	 			array_push($this->value, $parsed_block);
 			} 			
 			$this->parsed_block = str_replace($this->tag, $this->value, $this->blocks[$this->block_name]);
 			 			
 		}
 		
 		function reset()
 		{
 			$this->tag = array();
			$this->value = array();
 		}
 		
 		function re_replace($tag, $value) {
 			$key = array_search("{{$tag}}", $this->tag);
 			if ($key == NULL) return; 			
 			$this->value[$key]=$value; 			
 		}				 	
 	}
 	 	
 	 	
 	class new_noc_templater 
 	{
 		var $parsed_doc = "";
 		var $replacers = array();
 		var $blocks = array();
 		
 		var $replacer_ref = "";
 		var $current_replacer_key = 0;
 		 		 		
 		function new_noc_templater($template_file) 
 		{
 			$this->blocks["root"] = file_get_contents($template_file);
 			if(!$this->blocks["root"]) {
 				print "Template file ne postoji ili put nije dobro upisan !!!";
 				exit; 			
 			} 
 			 			 			 			
			$replacer_key = $this->create_replacer("root");						
			$this->replacer_ref = &$this->replacers[$replacer_key];
			
			//exit;								 			 			 			 			
 		}
 		
 		function replace($tag, $value)
 		{
 			$this->replacer_ref->replace($tag, $value);	
 		}
 		
 		function set_block($block_path)
		{
			//Stvori sve potrebne blokove ako ve nisu stvoreni i pravilno setiraj $this->replacer_ref
			$blocks = preg_split("/\[|\.|([0-9]+)\]\.?/", $block_path, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY); // "/\[([0-9]+)\]\.?/"
			
			$this->replacer_ref = &$this->replacers[0];
			for ($i = 0; $i < count($blocks); $i++)
			{
				//Radi samo s imenima blokova ne s indexima, indexe uredno preskoi ($i++;)
				if (empty($this->blocks[$blocks[$i]])) $this->create_block($blocks[$i]);
				if (!@preg_match("/[0-9]+/", $blocks[$i+1])) 
				{
					if ($blocks[$i] == "root") 
					{
						$this->replacer_ref = &$this->replacers[0];
						continue;
					}
					if (!empty($this->replacer_ref->children[$blocks[$i]][0]))
					{
						$this->replacer_ref = &$this->replacer_ref->children[$blocks[$i]][0];												
					}
					else
					{
						$replacer_key = $this->create_replacer($blocks[$i]);
						$this->replacer_ref->children[$blocks[$i]][0] = &$this->replacers[$replacer_key];
						$this->replacer_ref = &$this->replacers[$replacer_key];						
					}						
				}					
				else
				{
					if (!empty($this->replacer_ref->children[$blocks[$i]][$blocks[$i+1]]))
					{
						$this->replacer_ref = &$this->replacer_ref->children[$blocks[$i]][$blocks[$i+1]];												
					}
					else 
					{
						$replacer_key = $this->create_replacer($blocks[$i]); 
						$this->replacer_ref->children[$blocks[$i]][$blocks[$i+1]] = &$this->replacers[$replacer_key];
						$this->replacer_ref = &$this->replacers[$replacer_key];												
					}					
					$i++;				
				}
								
				
			}			
		}			
		
		function reset()
		{
			$this->replacer_ref->reset();	
		}
		
		function re_replace($tag, $value) {
			$this->replacer_ref->re_replace($tag, $value);			
		}
				
		function skip_block()
		{
			//$this->replacer_ref->skipped = true;
			$this->replacer_ref->block_name = ""; 					
		}
		
		function parse()
		{
			$this->replacers[0]->parse();
			$this->parsed_block = &$this->replacers[0]->parsed_block;			
		}
		
		function html_print()
		{
			print $this->parsed_block;	
		}
		
		function print_debug() {
			print_r($this->replacers);	
		}
		
		/************************************************************************************************ 
		 * Private functions
		 */
		function create_replacer($block_name)
		{
			array_push($this->replacers, new noc_template_replacer($block_name, $this->blocks));					
			return $this->get_last_array_key($this->replacers);  	
		}					
 		function create_block($block_name)
 		{
 			//Uzmi blok iz blocks[root] i spremi ga u blocks[$block_name]
			$begin_block_name = "<!-- BEGIN " . $block_name . " -->";
			$end_block_name = "<!-- END " . $block_name . " -->";
			
			$start_block_position = strpos($this->blocks["root"], $begin_block_name);
			$end_block_position = strpos($this->blocks["root"], $end_block_name);
							
			$block_s_pos = $start_block_position + strlen($begin_block_name);
			
			//NAPOMENA Pitanje je da li e kako e raditi s dva ista bloka razliita imena, nek ostane pa bumo vidli
			$tag_e_pos = $end_block_position;// + strlen($end_block_name);				
			//$this->blocks[$block_name] = substr($this->blocks[root], $start_block_position, $tag_e_pos - $start_block_position);
			$this->blocks[$block_name] = substr($this->blocks["root"], $block_s_pos, $tag_e_pos-$block_s_pos); 			
 		}
 	 		
 		function get_last_array_key(&$array)
 		{
 			//Ako templater nebu radil onda odkomentirati ovo a zakomentirati ono :-) (To je zbog nekompatibilnosti izmedju verzija PHP-a)
 			//$tmp = array_keys($array);
			//return end($tmp);
 			end($array);
			return key($array); 			
 		}
 		
 		function clear_empty_vars() {
 			//ako se pozove prije html_print onda prodji cijeli gotov html i repaceaj sve sto ima {}	
 		
 		}
 	} 
 
?>
